"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _events = _interopRequireDefault(require("events"));

var _invariant = _interopRequireDefault(require("invariant"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = ({
  methods = ['findById', 'findOne', 'findMany', 'createOne', 'createMany', 'updateOne', 'updateMany', 'replaceOne', 'deleteOne', 'deleteMany', 'save', 'count', 'query', 'aggregate'],
  emitter,
  prefix = ''
}) => repository => {
  (0, _invariant.default)(emitter instanceof _events.default, 'emitter has to be an instance of EventEmitter!');
  methods.forEach(method => {
    const previous = repository[method];
    Object.assign(repository, {
      [method]: async (...args) => {
        emitter.emit(`${prefix}before:${method}`, ...args);
        const result = await previous.call(repository, ...args);
        emitter.emit(`${prefix}after:${method}`, result, ...args);
        return result;
      }
    });
  });
  return repository;
};

exports.default = _default;