"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _util = _interopRequireDefault(require("util"));

var _withHooks = _interopRequireDefault(require("./withHooks"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (log = console.log.bind(console)) => repository => (0, _withHooks.default)({
  beforeAll: (method, ...args) => {
    const {
      name
    } = repository.constructor;
    const {
      collectionName
    } = repository;

    const formattedArgs = _util.default.inspect(args, {
      depth: null,
      colors: true
    });

    log(`${name}.${method} (${collectionName}) called with args: \n${formattedArgs}`);
  }
})(repository);

exports.default = _default;