"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _easevalidation = require("easevalidation");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const withSoftDeleteFilter = (propertyName, _ref = {}) => {
  let {
    query = {},
    noSoftDeleteFilter
  } = _ref,
      restArgs = _objectWithoutProperties(_ref, ["query", "noSoftDeleteFilter"]);

  return _objectSpread({
    query: _objectSpread({}, noSoftDeleteFilter ? {} : {
      [propertyName]: false
    }, {}, query)
  }, restArgs);
};

var _default = ({
  propertyName = 'isDeleted',
  timestampName = 'deletedAt'
} = {}) => repository => {
  const {
    findOne,
    findMany,
    count,
    updateOne,
    updateMany,
    deleteOne,
    deleteMany,
    aggregate
  } = repository;
  repository.validators.push(_easevalidation.validators.isSchema({
    [propertyName]: [_easevalidation.validators.isDefault(false), _easevalidation.validators.isBoolean()],
    [timestampName]: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), _easevalidation.validators.isDate())
  }));
  Object.assign(repository, {
    findOne: args => findOne.call(repository, withSoftDeleteFilter(propertyName, args)),
    findMany: args => findMany.call(repository, withSoftDeleteFilter(propertyName, args)),
    count: args => count.call(repository, withSoftDeleteFilter(propertyName, args)),
    deleteOne: (_ref2 = {}) => {
      let {
        query = {},
        noSoftDeleteFilter
      } = _ref2,
          restArgs = _objectWithoutProperties(_ref2, ["query", "noSoftDeleteFilter"]);

      return noSoftDeleteFilter ? deleteOne.call(repository, _objectSpread({
        query
      }, restArgs)) : updateOne.call(repository, {
        query,
        update: {
          $set: {
            [propertyName]: true,
            [timestampName]: new Date()
          }
        }
      });
    },
    deleteMany: (_ref3 = {}) => {
      let {
        query = {},
        noSoftDeleteFilter
      } = _ref3,
          restArgs = _objectWithoutProperties(_ref3, ["query", "noSoftDeleteFilter"]);

      return noSoftDeleteFilter ? deleteMany.call(repository, _objectSpread({
        query
      }, restArgs)) : updateMany.call(repository, {
        query,
        update: {
          $set: {
            [propertyName]: true,
            [timestampName]: new Date()
          }
        }
      });
    },
    aggregate: (_ref4) => {
      let {
        pipeline,
        options: {
          noSoftDeleteFilter
        } = {}
      } = _ref4,
          restOptions = _objectWithoutProperties(_ref4.options, ["noSoftDeleteFilter"]);

      return aggregate.call(repository, {
        pipeline: noSoftDeleteFilter ? pipeline : [{
          $match: {
            [propertyName]: false
          }
        }, ...pipeline],
        options: restOptions
      });
    }
  });
  return repository;
};

exports.default = _default;