"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _easevalidation = require("easevalidation");

var _set = _interopRequireDefault(require("lodash/set"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const addTsToUpdate = (update, updateProperty) => {
  let {
    $set
  } = update;

  if (!$set) {
    $set = {};
  }

  $set[updateProperty] = new Date();
  return _objectSpread({}, update, {
    $set
  });
};

var _default = ({
  createProperty = 'createdAt',
  updateProperty = 'updatedAt'
} = {}) => repository => {
  const {
    createOne,
    createMany,
    updateOne,
    updateMany,
    replaceOne
  } = repository;
  repository.validators.push(_easevalidation.validators.isSchema({
    [createProperty]: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), _easevalidation.validators.isDate()),
    [updateProperty]: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), _easevalidation.validators.isDate())
  }));
  Object.assign(repository, {
    createOne(data, ...restArgs) {
      if (typeof data === 'object') {
        (0, _set.default)(data, createProperty, new Date());
      }

      return createOne.call(repository, data, ...restArgs);
    },

    createMany(data, ...restArgs) {
      return createMany.call(repository, Array.isArray(data) ? data.map(item => {
        (0, _set.default)(item, createProperty, new Date());
        return item;
      }) : data, ...restArgs);
    },

    updateOne(_ref, ...restArgs) {
      let {
        update
      } = _ref,
          restUpdateArgs = _objectWithoutProperties(_ref, ["update"]);

      return updateOne.call(repository, _objectSpread({}, restUpdateArgs, {
        update: addTsToUpdate(update, updateProperty)
      }), ...restArgs);
    },

    updateMany(_ref2, ...restArgs) {
      let {
        update
      } = _ref2,
          restUpdateArgs = _objectWithoutProperties(_ref2, ["update"]);

      return updateMany.call(repository, _objectSpread({}, restUpdateArgs, {
        update: addTsToUpdate(update, updateProperty)
      }), ...restArgs);
    },

    replaceOne(_ref3) {
      let {
        query,
        replacement
      } = _ref3,
          restArgs = _objectWithoutProperties(_ref3, ["query", "replacement"]);

      (0, _set.default)(replacement, updateProperty, new Date());
      return replaceOne.call(repository, _objectSpread({
        query,
        replacement
      }, restArgs));
    }

  });
  return repository;
};

exports.default = _default;