"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _easevalidation = require("easevalidation");

var _withValidator = _interopRequireDefault(require("oors-graphql/build/decorators/withValidator"));

var _isObjectId = _interopRequireDefault(require("../libs/isObjectId"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = ({
  maxPerPage = 20,
  defaultPerPage = 10
} = {}) => (0, _withValidator.default)(_easevalidation.validators.isSchema({
  skip: [_easevalidation.validators.isDefault(0), _easevalidation.validators.isMin(0), _easevalidation.validators.isInteger()],
  after: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), (0, _isObjectId.default)()),
  before: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), (0, _isObjectId.default)()),
  first: [_easevalidation.validators.isDefault(defaultPerPage), _easevalidation.validators.isMin(1), _easevalidation.validators.isMax(maxPerPage), _easevalidation.validators.isInteger()],
  last: _easevalidation.validators.isAny(_easevalidation.validators.isUndefined(), _easevalidation.validators.isEvery(_easevalidation.validators.isMin(1), _easevalidation.validators.isMax(maxPerPage), _easevalidation.validators.isInteger())),
  where: [_easevalidation.validators.isDefault({}), _easevalidation.validators.isRequired(), _easevalidation.validators.isObject()]
}));

exports.default = _default;