"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isRelation = void 0;

var _intersection = _interopRequireDefault(require("lodash/intersection"));

var _easevalidation = require("easevalidation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const isRelation = _easevalidation.validators.isEvery(_easevalidation.validators.isSchema({
  localField: [_easevalidation.validators.isRequired(), _easevalidation.validators.isString()],
  foreignField: [_easevalidation.validators.isRequired(), _easevalidation.validators.isString()],
  type: _easevalidation.validators.isOneOf(['one', 'many']),
  collectionName: _easevalidation.validators.isAny([_easevalidation.validators.isUndefined(), _easevalidation.validators.isString()]),
  repositoryName: _easevalidation.validators.isAny([_easevalidation.validators.isUndefined(), _easevalidation.validators.isString()]),
  repository: _easevalidation.validators.isAny([_easevalidation.validators.isUndefined(), _easevalidation.validators.isObject()])
}), _easevalidation.validators.isValid(relation => (0, _intersection.default)(Object.keys(relation), ['collectionName', 'repositoryName', 'repository']).length === 1));

exports.isRelation = isRelation;