"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _uniq = _interopRequireDefault(require("lodash/uniq"));

var _oorsMongodb = require("oors-mongodb");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class _default extends _oorsMongodb.Migration {
  constructor(...args) {
    super(...args);
    this.name = 'Create Collections';
  }

  getCollectionNames() {
    return (0, _uniq.default)(Object.keys(this.modules.get('oors.mongodb').repositories).map(repositoryName => this.getCollectionName(repositoryName)));
  }

  async up() {
    await Promise.all(this.getCollectionNames().map(name => this.createCollection(name)));
  }

  async down() {
    return Promise.all(this.getCollectionNames().map(name => this.dropCollection(name)));
  }

}

exports.default = _default;